﻿namespace HeuristicLab.BenchmarkSuite
{
  using System.Collections.Generic;

  using HeuristicLab.Core;
  using HeuristicLab.Random;

  public abstract class BenchmarkSuiteDataDescritpor<T> : ArtificialDataDescriptor
  {
    protected static IRandom rand = new FastRandom();

    protected abstract IEnumerable<T> GenerateTraining();

    protected abstract IEnumerable<T> GenerateTest();

    protected abstract IEnumerable<Example> GenerateExamples(IEnumerable<T> trainingAndTest);

    protected override IEnumerable<Example> GenerateExamples()
    {
      var training = this.GenerateTraining();

      training = training.Shuffle(rand);

      var test = this.GenerateTest();

      var all = new List<T>();
      all.AddRange(training);
      all.AddRange(test);

      return this.GenerateExamples(all);
    }
  }
}